//
// Copyright  Diehl Graphsoft, Inc. 2006.
// All Rights Reserved.
// 

#pragma once

#include "IFileIdentifier.h"

namespace VectorWorks
{
	namespace Filing
	{

		// ----------------------------------------------------------------------------------------------------
		// {263BD4CD-417F-4fc0-8BEE-9CBFF95FDC76}
		static const VWIID IID_IImportExportDWG = { 0x2f790ffd, 0x416d, 0x428b, { 0x93, 0xa0, 0xff, 0xe5, 0x79, 0x8, 0x0, 0x71 } }; 
		
		class DYNAMIC_ATTRIBUTE IImportExportDWG : public IVWUnknown
		{
		public:
			virtual VCOMError VCOM_CALLTYPE	Import() = 0;
			virtual VCOMError VCOM_CALLTYPE	Import(IFileIdentifier* pFileID, const bool isSilentDWGImport) = 0;
			virtual VCOMError VCOM_CALLTYPE	Export() = 0;
			virtual VCOMError VCOM_CALLTYPE	Export(IFileIdentifier* pFileID) = 0;
			virtual VCOMError VCOM_CALLTYPE	IsDXFImport(bool& isDXFImport) = 0;
			virtual VCOMError VCOM_CALLTYPE	IsDXFExport(bool& isDXFExport) = 0;
		};

		// ----------------------------------------------------------------------------------------------------
		typedef VCOMPtr<IImportExportDWG>		IImportExportDWGPtr;
	}
}
