// CallbackParamTypes.h
//
// Copyright 1999 Diehl Graphsoft, Inc.
// All Rights Reserved.
//
// SourceSafe information for this version:
//    $Revision: 1 $
//    $Date: 6/06/00 6:07p $
//    $Author: Dave $

#ifndef _CALLBACKPARAMTYPES_
#define _CALLBACKPARAMTYPES_

#pragma once

#include "GSTypes.h"


#define MUST_PROMOTE_SCALARS 0


typedef Sint8				lbyte_t;
typedef Uint8				lubyte_t;
typedef Sint16				lshort_t;
typedef Uint16				lushort_t;
	

typedef lbyte_t				lboolean_t;

#if _WINDOWS
	typedef Real64			callback_double_param;
	typedef Real64			CBDouble_param;
	typedef const Real64  &CBWorldCoord_param;	// JAK 10/15/99 
#else
	// Callbacks always take FP params by reference because
	// Mixed Mode can't convert stack based to register based.
	typedef const Real64  &callback_double_param;
	typedef const Real64  &CBDouble_param;
	typedef const Real64  &CBWorldCoord_param;	// JAK 10/15/99 
#endif



typedef Sint8				CBSignedByte;
typedef Uint8				CBUnsignedByte;
typedef Sint16				CBSignedShort;
typedef Uint16				CBUnsignedShort;
typedef CBSignedByte		CBBoolean;
typedef Real64				CBDouble;


#endif // _CALLBACKPARAMTYPES_
