/*
 *  VWState.h
 *  VectorWorks
 *
 *  Created by Lyndsey Ferguson on 12/15/09.
 *  Copyright 2009 Nemetschek North America, Inc. All rights reserved.
 *
 */

#pragma once

// Generic State Saver
// -------------------

template <class T> class TState {
private:
	T		fSaveState;
	T&		fStateVariable;
	
	DISALLOW_DUPLICATES(TState);
	
public:
	TState(T& stateVariable) : fStateVariable(stateVariable)
	{ fSaveState = fStateVariable; }
	TState(T& stateVariable, const T& newValue) : fStateVariable(stateVariable)
	{ fSaveState = fStateVariable; fStateVariable = newValue; }
	~TState()
	{ fStateVariable = fSaveState; }
};