//
//	Copyright (c) 2005 Nemetschek North America 
//	All Rights Reserved.
//
// Created by Vladislav Stanev

#pragma once

#define _VWFC_LEGACY
#include "VWFC/PluginSupport/VWExtensions.h"

namespace VWFC
{
	namespace PluginSupport
	{
		// ---------------------------------------------------------------------------
		class VWPluginMenuApp
		{
		public:
								VWPluginMenuApp();
			virtual				~VWPluginMenuApp();

		public:
			virtual void		InitializeApp();
			virtual void		DeinitializeApp();

			virtual TXString	GetContextualHelpID() const;

			virtual void		DoInterface();
			virtual void		NotifyCallback(EMenuCallbackEvent event);

			virtual bool		GetItemEnabled();

			virtual long		GetUserData() const;
			virtual void		SetUserData(long userData);
			long				GetResult() const;
			void				SetResult(long result);
			void				SetMenuChunkInfo(MenuChunkInfo* pMenuChunkInfo);

			// The default event notificaiotn
			// if no virutal is present for an event, this function is called to allow the user to catch everything
			virtual long		OnDefaultEvent(long action, long message);

		public:
			void				RegisterForCallback(EMenuCallbackEvent event);
			void				UnRegisterForCallback(EMenuCallbackEvent event);

		protected:
			MenuChunkInfo*		fpMenuChunkInfo;
			long				fResult;
		};
	}
}

// ------------------------------------------------------------------------------
#define	INSTANTIATE_MENU_APP(T)	VWFC::PluginSupport::VWPluginMenuApp* CreateMenuInstance()  { void* pRawMem = malloc( sizeof(T) ); return (T*) new (pRawMem) T(); }
