#include "StdAfx.h"

#include "PluginResource.h"

#include "ExtTool.h"

using namespace VectorWorks::Filing;
using namespace TesterModule;

namespace TesterModule
{
	// --------------------------------------------------------------------------------------------------------
	static SToolDef		gToolDef = {
		/*ToolType*/					eExtensionToolType_Normal,
		/*ParametricName*/				"",
		/*PickAndUpdate*/				ToolDef::pickAndUpdate,
		/*NeedScreenPlane*/				ToolDef::doesntNeedScreenPlane,
		/*Need3DProjection*/			ToolDef::doesntNeed3DView,
		/*Use2DCursor*/					ToolDef::use2DCursor,
		/*ConstrainCursor*/				ToolDef::constrainCursor,
		/*NeedPerspective*/				ToolDef::doesntNeedPerspective,
		/*ShowScreenHints*/				ToolDef::showScreenHints,
		/*NeedsPlanarContext*/			ToolDef::needsPlanarContext,
		/*Reserved1*/					false,
		/*Reserved2*/					0,
		/*IconID*/						11000,
		/*DefaultCursorID*/				0, 
		/*Message*/						{13000, 3},
		/*WaitMoveDistance*/			0,
		/*ConstraintFlags*/				0,
		/*BarDisplay*/					kToolBarDisplay_XYClLaZo,
		/*MinimumCompatibleVersion*/	900,
		/*Title*/						{13000, 1},
		/*Category*/					{13000, 2},
		/*HelpText*/					{13000},
		/*VersionCreated*/				16,
		/*VersoinModified*/				0,
		/*VersoinRetired*/				0
	};
}

// --------------------------------------------------------------------------------------------------------
// {DF0D9D08-1704-4c9c-B2BF-18CA526267BA}
IMPLEMENT_VWExtension(
	/*Extension class*/	CExtTool,
	/*Event sink*/		CTool_EventSink,
	/*Universal name*/	"CExtTool",
	/*Version*/			1,
	/*UUID*/			0xdf0d9d08, 0x1704, 0x4c9c, 0xb2, 0xbf, 0x18, 0xca, 0x52, 0x62, 0x67, 0xba );

// --------------------------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------------------------
CExtTool::CExtTool(CallBackPtr cbp)
	: VWExtensionTool( cbp, gToolDef )
{
}

CExtTool::~CExtTool()
{
}

// --------------------------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------------------------
CTool_EventSink::CTool_EventSink(IVWUnknown* parent)
	: VWTool_EventSink( parent )
{
}

CTool_EventSink::~CTool_EventSink()
{
}

void CTool_EventSink::Draw(IToolDrawProvider* pDrawProvider)
{
}

void CTool_EventSink::HandleComplete()
{
	VWPoint3D	pt	= this->GetToolPt3D( 0 );

	VWParametricObj	paramObj( "CExtObj", VWPoint2D(pt.x,pt.y) );

	VWTransformMatrix	matrix;
	paramObj.GetObjectMatrix( matrix );
	matrix.SetOffset( pt );
	paramObj.SetObjectMatrix( matrix );
}


